/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/

/*
 * @(#)Literal.java	1.4 07/05/04
 */

package com.sun.mail.iap;

import java.io.*;

/**
 * An interface for objects that provide data dynamically for use in
 * a literal protocol element.
 *
 * @version 1.4, 07/05/04
 * @author  Bill Shannon
 */

public interface Literal {
    /**
     * Return the size of the data.
     */
    public int size();

    /**
     * Write the data to the OutputStream.
     */
    public void writeTo(OutputStream os) throws IOException;
}
