/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/

/*
 * @(#)IllegalWriteException.java	1.6 07/05/04
 */

package javax.mail;


/**
 * The exception thrown when a write is attempted on a read-only attribute
 * of any Messaging object. 
 *
 * @author John Mani
 */

public
class IllegalWriteException extends MessagingException {

    private static final long serialVersionUID = 3974370223328268013L;

    /**
     * Constructs a IllegalWriteException with no detail message.
     */
    public IllegalWriteException() {
	super();
    }

    /**
     * Constructs a IllegalWriteException with the specified detail message.
     * @param s		the detail message
     */
    public IllegalWriteException(String s) {
	super(s);
    }
}
