/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/

/*
 * @(#)NoSuchProviderException.java	1.7 07/05/04
 */

package javax.mail;

/**
 * This exception is thrown when Session attempts to instantiate a  
 * Provider that doesn't exist.
 * 
 * @author Max Spivak
 */

public class NoSuchProviderException extends MessagingException {

    private static final long serialVersionUID = 8058319293154708827L;
    
    /**
     * Constructor.
     */
    public NoSuchProviderException() {
	super();
    }

    /**
     * Constructor.
     * @param message	The detailed error message
     */
    public NoSuchProviderException(String message) {
	super(message);
    }
}
