/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/

/*
 * @(#)PasswordAuthentication.java	1.6 07/05/04
 */

package javax.mail;


/**
 * The class PasswordAuthentication is a data holder that is used by
 * Authenticator.  It is simply a repository for a user name and a password.
 *
 * @see java.net.PasswordAuthentication
 * @see javax.mail.Authenticator
 * @see javax.mail.Authenticator#getPasswordAuthentication()
 *
 * @author  Bill Foote
 * @version 1.6, 05/04/07
 */

public final class PasswordAuthentication {

    private String userName;
    private String password;

    /** 
     * Initialize a new PasswordAuthentication
     * @param userName the user name
     * @param password The user's password
     */
    public PasswordAuthentication(String userName, String password) {
	this.userName = userName;
	this.password = password;
    }

    /**
     * @return the user name
     */
    public String getUserName() {
	return userName;
    }

    /**
     * @return the password
     */
    public String getPassword() {
	return password;
    }
}
