/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/

/*
 * @(#)FolderAdapter.java	1.5 07/05/04
 */

package javax.mail.event;

/**
 * The adapter which receives Folder events.
 * The methods in this class are empty;  this class is provided as a
 * convenience for easily creating listeners by extending this class
 * and overriding only the methods of interest.
 *
 * @author John Mani
 */
public abstract class FolderAdapter implements FolderListener {
    public void folderCreated(FolderEvent e) {}
    public void folderRenamed(FolderEvent e) {}
    public void folderDeleted(FolderEvent e) {}
}
