/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/

/*
 * @(#)SearchException.java	1.9 07/05/04
 */

package javax.mail.search;

import javax.mail.MessagingException;


/**
 * The exception thrown when a Search expression could not be handled.
 *
 * @author John Mani
 */

public class SearchException extends MessagingException {

    private static final long serialVersionUID = -7092886778226268686L;

    /**
     * Constructs a SearchException with no detail message.
     */
    public SearchException() {
	super();
    }

    /**
     * Constructs a SearchException with the specified detail message.
     * @param s		the detail message
     */
    public SearchException(String s) {
	super(s);
    }
}
