/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/

package org.eclipse.ebpm.components.xsdvalidator;

import org.xml.sax.ErrorHandler;

public interface MessageAwareErrorHandler extends ErrorHandler {
	
    /**
     * Does the error handler contain any error messages?
     * 
     * @return
     */
	public boolean hasErrors();

    /**
     * Return the number of warnings.
     * 
     * @return
     */
	public int getWarningCount();

    /**
     * Return the number of errors.
     * 
     * @return
     */
	public int getErrorCount();

    /**
     * Return the number of fatal errors.
     * 
     * @return
     */
    public int getFatalErrorCount();

	
	
	
	public String getErrorMessageAsXML();
	
	
}
