/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.connectors.filesystem.adapters;

import java.io.BufferedWriter;
import java.io.InputStream;

import org.eclipse.ebpm.messaging.api.Exchange;
import org.eclipse.ebpm.messaging.api.Message;

public interface IFileAdapter {
	
	public static final String FILE_NAME_PROPERTY = "spagic.filename";
	
	public static final String FILE_PATH_PROPERTY = "spagic.filepath";
	
	public String getOutputFileName(Exchange exchange, Message in);
	
	public String getAdapterId();
	
	public void writeMessage(Exchange exchange, Message in, BufferedWriter bw) throws Exception;
	
	public void readFile(Exchange exchange, Message in, InputStream is, String filePath) throws Exception;
	
	//public void readFileNotXml(Exchange exchange, Message in, InputStream is, String filePath) throws Exception;
	
}
