/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.connectors.ftp;


/**
 * Exception thrown if the connection could not be established.
 *
 * @version $Revision: 426415 $
 */
public class ConnectionRefusedException extends RuntimeException {
    
    private final int code;

    public ConnectionRefusedException(int code) {
        super("Connection refused with return code: " + code);
        this.code = code;
    }

    /**
     * @return the status code for why the connection was refused
     */
    public int getCode() {
        return code;
    }
}
