/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.connectors.http.adapters;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.eclipse.ebpm.messaging.api.Exchange;
import org.eclipse.ebpm.messaging.api.Message;
import org.eclipse.ebpm.util.properties.PropertyConfigurator;


public interface IHTTPInputProtocolAdapter extends IHTTPAdapter {
	
	public Exchange createExchange(HttpServletRequest request, String mep, String sender, String target, PropertyConfigurator pc, Object binding) throws Exception;
	public void sendAccepted(Exchange exchange, HttpServletRequest request, HttpServletResponse response,  PropertyConfigurator pc, Object binding) throws Exception;
	public void sendError(Exchange exchange, Exception e, HttpServletRequest request, HttpServletResponse response, PropertyConfigurator pc, Object binding) throws Exception;
	public void sendFault(Exchange exchange, Message fault,HttpServletRequest request, HttpServletResponse response, PropertyConfigurator pc, Object binding) throws Exception;
	public void sendOut(Exchange exchange, Message out,HttpServletRequest request, HttpServletResponse response, PropertyConfigurator pc, Object binding) throws Exception;
	
}
