/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.connectors.jms.marshaler;

import javax.jms.Message;
import javax.jms.Session;

import org.eclipse.ebpm.messaging.api.Exchange;

public interface JmsConsumerMarshaler {
        
    Exchange createExchange(Message message) throws Exception;
    
    Message createOut(Exchange exchange, 
    		org.eclipse.ebpm.messaging.api.Message outMsg,
                      Session session) throws Exception;
    
    Message createFault(Exchange exchange, 
    		org.eclipse.ebpm.messaging.api.Message fault,
                        Session session) throws Exception;
    
    Message createError(Exchange exchange,
                        Exception error,
                        Session session) throws Exception;

}
