/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.connectors.jms.marshaler;

import javax.jms.Message;
import javax.jms.Session;

import org.eclipse.ebpm.messaging.api.Exchange;

public interface JmsProviderMarshaler {

    Message createMessage(Exchange exchange, org.eclipse.ebpm.messaging.api.Message in, Session session) throws Exception;

    void populateMessage(Message message, Exchange exchange, org.eclipse.ebpm.messaging.api.Message  normalizedMessage) throws Exception;
    
    /**
     * @param needJavaIdentifiers The needJavaIdentifiers to set.
     */
    void setNeedJavaIdentifiers(boolean needJavaIdentifiers);
}
