/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.connectors.quartz.adapters;

import org.eclipse.ebpm.messaging.api.Message;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;

public interface IQuartzAdapter {
	
	/**
     * Populates the given normalized message from the Quartz context
     *
     * @param message the normalized message to populate
     * @param context the Quartz context
     * @throws JobExecutionException
     */
    void populateNormalizedMessage(Message message, JobExecutionContext context)
        throws JobExecutionException;

	
}
