/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.core;

import org.eclipse.ebpm.constants.SpagicConstants;

public class SpagicNode {

	public static String id(){
		String nodeId = System.getProperty(SpagicConstants.SPAGIC_NODE_IDENTIFIER);
		return nodeId;
		/*
		if (nodeId != null){
			return System.getProperty(SpagicConstants.SPAGIC_NODE_IDENTIFIER);
		}else{
			return "node1";
		}
		*/
		
	}
	
	public static String baseTopic(){
		return SpagicUtils.normalizeTopic(SpagicConstants.SPAGIC_BASE_TOPIC + id() + "/");	
	}
	
	public static String topicForService(String localServiceId){
		String topic =  baseTopic() + localServiceId;
		return SpagicUtils.normalizeTopic(topic);
	}
	
	
	public static String topicForServiceAndExternalNode(String localServiceId, String nodeId){
		String topic =  SpagicConstants.SPAGIC_BASE_TOPIC + nodeId + "/"+ localServiceId;
		return SpagicUtils.normalizeTopic(topic);
	}
	
	public static String nodeType(){
		return System.getProperty(SpagicConstants.SPAGIC_NODE_TYPE);
	}
	public static boolean isMaster(){
		// If nodeType is not specified it's master by default
		return (nodeType() != null ? nodeType().equalsIgnoreCase(SpagicConstants.SPAGIC_NODE_TYPE_MASTER) : true);
	}
	
	public static boolean isSlave(){
		return (nodeType() != null ? nodeType().equalsIgnoreCase(SpagicConstants.SPAGIC_NODE_TYPE_SLAVE) : false);
	}
	
	public static boolean isClusteredEnabled(){
		String clusterEnabled = System.getProperty(SpagicConstants._IS_CLUSTER_ENABLED);
		return (clusterEnabled != null ?  Boolean.valueOf(clusterEnabled) : false);
		
	}
	
	public static String clusterId(){
		return System.getProperty(SpagicConstants._CLUSTER_ID);
	}
	
	public static String referredMaster(){
		return System.getProperty(SpagicConstants._SLAVE_MASTER);
	}
	
	public static boolean masterSlaveEnabled(){
		String masterSlaveEnabled = System.getProperty(SpagicConstants._IS_MASTER_SLAVE_ENABLED);
		return (masterSlaveEnabled != null ?  Boolean.valueOf(masterSlaveEnabled) : false);

	}
	
	public static String masterSlaveClusterId(){
		if (isMaster())
			return id() + "MasterSlave";
		else if (isSlave())
			return referredMaster() + "MasterSlave";
		else
			return null;
	}
	
	
}
