/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.core;

import java.io.StringWriter;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;

public class SpagicUtils {

	protected final static TransformerFactory tf = TransformerFactory
			.newInstance();

	

	public static String normalizeTopic(String topic) {
		String newTopic =  topic.replaceAll("\\.", "-");
		newTopic = topic.replaceAll("@", "-");
		return newTopic;
		
	}

	/**
	 * Converts the given input Source into the required result
	 */
	protected static void toResult(Source source, Result result)
			throws TransformerException {

		if (source == null) {
			return;
		}
		Transformer transformer = tf.newTransformer();
		if (transformer == null) {
			throw new TransformerException(
					"Could not create a transformer - JAXP is misconfigured!");
		}
		transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8");
		transformer.transform(source, result);

	}

	/**
	 * Converts the given input Source into text
	 */
	public static String toString(Source source) {
		try {
			if (source == null) {
				return null;
			} else {
				StringWriter buffer = new StringWriter();
				toResult(source, new StreamResult(buffer));
				return buffer.toString();
			}
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
	
	/*
	public static String xpathEvaluateString(String xml, String xPath) {
		Object result = xpathEvaluate(xml, xPath);
		if (result instanceof String) {
			return (String) result;
		} else if (result instanceof Element) {
			return ((Element)result).getText();
		}
		return null;
	}
	

	
	public static Object xpathEvaluate(String xml, String xPath) {
		try {
			Document document = DocumentHelper.parseText(xml);

			List<Namespace> namespaces = new ArrayList<Namespace>();
			retrieveNamespace(document.getRootElement(), namespaces);

			Map<String, String> namespaceMap = new HashMap<String, String>();
			for (Namespace n : namespaces) {
				namespaceMap.put(n.getPrefix(), n.getURI());
			}

			XPath xpath = new DefaultXPath(xPath);
			xpath.setNamespaceURIs(namespaceMap);
			return xpath.evaluate(document);

		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}
	*/

	/*

	private static void retrieveNamespace(Element el, List l) {
		l.addAll(el.declaredNamespaces());
		if (!isLeaf(el)) {
			List<Element> childs = el.elements();
			for (Element e : childs)
				retrieveNamespace(e, l);
		}
	}

	public static boolean isLeaf(Element elem) {
		return elem.elements().size() == 0;
	}	

	*/
}
