/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.deployer;

import java.util.Hashtable;
import java.util.List;

public interface IDeploymentService {
	
	public static final String SPAGIC_SERVICE = "SPAGIC_SERVICE";
	public static final String SPAGIC_CONNECTOR = "SPAGIC_CONNECTOR";
	public static final String SPAGIC_DATASOURCE = "SPAGIC_DATASOURCE";
	public static final String SPAGIC_CONNECTIONFACTORY = "SPAGIC_CONNECTIONFACTORY";
		
	public void deployService(String spagicId, String factoryName, Hashtable properties);
	public void undeployService(String spagicId);
	
	public void deployConnector(String spagicId, String factoryName, Hashtable properties);
	public void undeployConnector(String spagicId);
	
	public void deployDatasource(String dataSourceID, Hashtable properties);
	public void undeployDatasource(String dataSourceID);
	
	public void deployConnectionFactory(String connectionFactoryID, String factoryName, Hashtable properties);
	public void undeployConnectionFactory(String connectionFactoryID);
	
	public void deployRoutes(List<String> updateRoutes, List<String> oldRoutes);
	
	
	
}
