/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.graph.parser;

public interface IProcessInfo {
	
// --------------- Protocol independent states ---------------
	
	public static final int TRANSITION_MISSING = -1;		// Not executed 
	public static final int TRANSITION_DONE = -2;		// Completed successfully
	public static final int TRANSITION_ACTIVE = -3;	// Executing
	public static final int TRANSITION_WARNING = -4;	// Warning 
	public static final int TRANSITION_FAULTED = -5;	// Faulted 
	
	public StepInfo getStepInfo(String stepName);
	
	public int getExecutionStateInstanceService(String stepName, long processInstanceId);
	
	public SubProcessInfo getSubProcessInfo(String stepName);

}