/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.graph.parser;

public class StepInfo {
		
	private String stepName;
	private String originalStepName;
	private String stepID;
	private int stepState;
	private boolean isStartStep;
	
	public StepInfo(String stepID, String stepName, String originalStepName, int stepState, boolean isStartStep){
		this.stepID = stepID;
		this.stepName = stepName;
		if (originalStepName != null && !originalStepName.equalsIgnoreCase(""))
			this.originalStepName = originalStepName;
		else 
			this.originalStepName = this.stepName;
		this.stepState = stepState;
		this.isStartStep = isStartStep;
	}

	public String getStepName() {
		return stepName;
	}

	public void setStepName(String stepName) {
		this.stepName = stepName;
	}

	public String getStepID() {
		return stepID;
	}

	public void setStepID(String stepID) {
		this.stepID = stepID;
	}

	public int getStepState() {
		return stepState;
	}

	public void setStepState(int stepState) {
		this.stepState = stepState;
	}

	public boolean isStartStep() {
		return isStartStep;
	}

	public void setStartStep(boolean isStartStep) {
		this.isStartStep = isStartStep;
	}

	public String getOriginalStepName() {
		return originalStepName;
	}

	public void setOriginalStepName(String originalStepName) {
		this.originalStepName = originalStepName;
	}

}
