/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.graph.util.test;

import java.io.ByteArrayOutputStream;
import java.io.File;

import org.eclipse.ebpm.graph.util.Graph;
import org.eclipse.ebpm.graph.util.GraphEndNode;
import org.eclipse.ebpm.graph.util.GraphNode;
import org.eclipse.ebpm.graph.util.GraphStartNode;

public class TestSVG {
	public static void main(String[] args) {
		TestSVG p = new TestSVG();
		p.start();
	}
	
	private void writeSVGToFile(Graph graph, String fileName){
		File f  = new File(fileName);	
		System.out.print(graph.getDotSource());
		graph.writeGraphToFile(graph.getGraph(graph.getDotSource()), f);
	}
	
	private void start() {
		
		
		/*
		Graph gv = new Graph();
		
		String dotStr = "digraph tcpconsumersync {\n"+
			// Start Node
			"123 [label=\"123\", fontsize=\"8\", tooltip=\"Detail\", URL=\"null\", color=gray, shape=circle]\n"+
			
			// Normal Task
			"124 [label=\"1234567891\", decorate=\"true\", fontsize=\"6\" fontname=\"Tahoma\", tooltip=\"Detail\", color=gray, shape=box style=rounded]\n " +
			"125 [label=\"125\", fontsize=\"8\", tooltip=\"Detail\", URL=\"null\", color=gray, shape=box style=rounded]\n " +
			"126 [label=\"126\", fontsize=\"8\", tooltip=\"Detail\", URL=\"null\", color=gray, shape=box style=rounded]\n " +
			"127 [label=\"127\", fontsize=\"8\", tooltip=\"Detail\", URL=\"null\", color=gray, shape=box style=rounded]\n " +
			"128 [label=\"128\", fontsize=\"8\", tooltip=\"Detail\", URL=\"null\", color=gray, shape=box style=rounded]\n " +
			"129 [label=\"129\", fontsize=\"8\", tooltip=\"Gateway\", URL=\"null\", color=gray, shape=diamond]"+
			"130 [label=\"130\", fontsize=\"8\", tooltip=\"Detail\", URL=\"null\", color=gray, shape=box style=rounded]\n " +
			"131 [label=\"130\", fontsize=\"8\", tooltip=\"Detail\", URL=\"null\", color=gray, shape=box style=rounded]\n " +
			"132 [label=\"129\", fontsize=\"8\", tooltip=\"Join\", URL=\"null\", color=gray, style=rounded, shape=diamond]"+
			"200 [label=\"200\", fontsize=\"8\", tooltip=\"Detail\",  URL=\"null\", color=gray, shape=circle style=\"rounded,bold\"]\n " +
			"123->125\n"+
			"124->128\n"+
			"125->126\n"+
			"126->124\n"+
			"127->129\n"+
			"128->127\n"+
			"129->130\n"+
			"129->131\n"+
			"130->132\n"+
			"131->132\n"+
			"132->200\n"+
			"}\n";
		
		File out = new File("C:/tmp/outgv.svg");
		gv.writeGraphToFile(gv.getGraph(dotStr), out);
		*/

		Graph gv = new Graph();
		gv.startGraph();
		GraphNode startNode = new GraphStartNode(String.valueOf("Start"), String.valueOf("Start"));
		GraphNode syncNode = new GraphNode(String.valueOf("Sync"), String.valueOf("Sync"));
		GraphNode taskNode = new GraphNode(String.valueOf("Task0"),String.valueOf("Task0"));
		GraphNode taskNode2 = new GraphNode(String.valueOf("Task1"),String.valueOf("Task1"));
		
		
		gv.addNode(startNode);
		gv.addNode(taskNode);
		gv.addNode(taskNode2);
		gv.addNode(syncNode);
		
		
	
		
			
		gv.addFlow(new org.eclipse.ebpm.graph.util.Transition("Start", "Sync"));
		gv.addFlow(new org.eclipse.ebpm.graph.util.Transition("Sync", "Start"));
		gv.addFlow(new org.eclipse.ebpm.graph.util.Transition("Sync", "Task0"));
		gv.addFlow(new org.eclipse.ebpm.graph.util.Transition("Task0", "Task1"));
		gv.addFlow(new org.eclipse.ebpm.graph.util.Transition("Task1", "Sync"));
		gv.endGraph();
		writeSVGToFile(gv, "C:/tmp/outNoColor.svg");
		
		/*
		gv = new Graph();
		gv.startGraph();
		startNode = new GraphStartNode(String.valueOf("Start"), String.valueOf("Start"));
		startNode.setFillColor("red");
		taskNode = new GraphNode(String.valueOf("Task"),String.valueOf("Task"));
		taskNode.setFillColor("red");
		endNode = new GraphEndNode(String.valueOf("End"), String.valueOf("End"));
		endNode.setFillColor("red");
		gv.addNode(startNode);
		gv.addNode(taskNode);
		gv.addNode(endNode);	
		gv.addFlow(new org.eclipse.ebpm.graph.util.Transition("Start", "Task"));
		gv.addFlow(new org.eclipse.ebpm.graph.util.Transition("Task", "End"));
		gv.endGraph();
		writeSVGToFile(gv, "C:/tmp/outColor.svg");
		*/
	}
}
