/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.attachments.model;

import java.io.Serializable;
import javax.persistence.*;


/**
 * The persistent class for the attachments database table.
 * 
 */
@Entity
@Table(name="attachments")
public class Attachment implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@Column(name="id")
	@GeneratedValue(generator = "attachments_gen")
	@SequenceGenerator(name = "attachments_gen", sequenceName="seq_attachments", allocationSize=1)
	private Long id;

	private String correlationid;

    @Lob()
	private byte[] data;

    public Attachment() {
    }

	public Long getId() {
		return this.id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getCorrelationid() {
		return this.correlationid;
	}

	public void setCorrelationid(String correlationid) {
		this.correlationid = correlationid;
	}

	public byte[] getData() {
		return this.data;
	}

	public void setData(byte[] data) {
		this.data = data;
	}

}