/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.customize;

import java.util.Map;
import org.eclipse.persistence.config.SessionCustomizer;
import org.eclipse.persistence.descriptors.ClassDescriptor;
import org.eclipse.persistence.sequencing.NativeSequence;
import org.eclipse.persistence.sequencing.Sequence;
import org.eclipse.persistence.sessions.Session;

public class MetaDBSessionCustomizer implements SessionCustomizer {
	
	public void customize(Session session) throws Exception {
		Map<Object, Object> descriptors = session.getDescriptors();
	
		for (Object key : descriptors.keySet()){
			Object value = descriptors.get(key);
			// System.out.println("Key = ["+key.getClass().getName()+"] ->" + key);
			// System.out.println("Value = ["+value.getClass().getName()+"] ->" + value);
			ClassDescriptor cdesc = (ClassDescriptor)value;
		
			String seqName = cdesc.getSequenceNumberName();
			Sequence seq = cdesc.getSequence();
			
			if (seq == null){
				seq = session.getDatasourcePlatform().getSequence(seqName);
			}
		
			if (seq instanceof NativeSequence){
				((NativeSequence) seq).setShouldUseIdentityIfPlatformSupports(true);
			}
			
		}
	}

}
