/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;
import java.util.List;


/**
 * The persistent class for the pool_instance database table.
 * 
 */
@Entity
@Table(name="pool_instance")
public class PoolInstance implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue( generator = "id_pool_gen")
	@Column(name="id_pool")
	@SequenceGenerator(name = "id_pool_gen",sequenceName="seq_pool_instance", allocationSize = 1)
	private Long idPool;

	@Column(name="unique_pool_instance_key")
	private String uniquePoolInstanceKey;

	//bi-directional many-to-one association to PoolType
    @ManyToOne
	@JoinColumn(name="id_pool_type")
	private PoolType poolType;

	//bi-directional many-to-one association to ProcessInstance
	@OneToMany(mappedBy="poolInstance")
	private List<ProcessInstance> processInstances;

    public PoolInstance() {
    }

	public Long getIdPool() {
		return this.idPool;
	}

	public void setIdPool(Long idPool) {
		this.idPool = idPool;
	}

	public String getUniquePoolInstanceKey() {
		return this.uniquePoolInstanceKey;
	}

	public void setUniquePoolInstanceKey(String uniquePoolInstanceKey) {
		this.uniquePoolInstanceKey = uniquePoolInstanceKey;
	}

	public PoolType getPoolType() {
		return this.poolType;
	}

	public void setPoolType(PoolType poolType) {
		this.poolType = poolType;
	}
	
	public List<ProcessInstance> getProcessInstances() {
		return this.processInstances;
	}

	public void setProcessInstances(List<ProcessInstance> processInstances) {
		this.processInstances = processInstances;
	}
	
}