/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;


/**
 * The persistent class for the process_diagram database table.
 * 
 */
@Entity
@Table(name="process_diagram")
public class ProcessDiagram implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.TABLE)
	@Column(name="id_process", updatable = false, insertable = false)
	private Long idProcess;

    @Lob()
	@Column(name="svg_diag")
	private String svgDiag;

	//bi-directional one-to-one association to Process
	@OneToOne
	@JoinColumn(name="id_process")
	private Process process;

    public ProcessDiagram() {
    }

	public Long getIdProcess() {
		return this.idProcess;
	}

	public void setIdProcess(Long idProcess) {
		this.idProcess = idProcess;
	}

	public String getSvgDiag() {
		return this.svgDiag;
	}

	public void setSvgDiag(String svgDiag) {
		this.svgDiag = svgDiag;
	}

	public Process getProcess() {
		return this.process;
	}

	public void setProcess(Process process) {
		this.process = process;
	}
	
}