/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;
import java.util.List;


/**
 * The persistent class for the process_execution_state database table.
 * 
 */
@Entity
@Table(name="process_execution_state")
public class ProcessExecutionState implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.TABLE)
	@Column(name="id_process_execution_state")
	private Long idProcessExecutionState;

	@Column(name="state_value")
	private String stateValue;

	//bi-directional many-to-one association to ProcessInstance
	@OneToMany(mappedBy="processExecutionState")
	private List<ProcessInstance> processInstances;

    public ProcessExecutionState() {
    }
    
    public ProcessExecutionState(Long idProcessExecutionState) {
		this.idProcessExecutionState = idProcessExecutionState;
	}

	public ProcessExecutionState(Long idProcessExecutionState, String stateValue) {
		this.idProcessExecutionState = idProcessExecutionState;
		this.stateValue = stateValue;
	}

	public Long getIdProcessExecutionState() {
		return this.idProcessExecutionState;
	}

	public void setIdProcessExecutionState(Long idProcessExecutionState) {
		this.idProcessExecutionState = idProcessExecutionState;
	}

	public String getStateValue() {
		return this.stateValue;
	}

	public void setStateValue(String stateValue) {
		this.stateValue = stateValue;
	}

	public List<ProcessInstance> getProcessInstances() {
		return this.processInstances;
	}

	public void setProcessInstances(List<ProcessInstance> processInstances) {
		this.processInstances = processInstances;
	}
	
}