/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;


/**
 * The persistent class for the property_service_instance database table.
 * 
 */
@Entity
@Table(name="property_service_instance")
public class PropertyServiceInstance implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(generator = "property_service_instance_gen")
	@Column(name="id_property")
	@SequenceGenerator(name = "property_service_instance_gen", sequenceName="seq_property_service_instance", allocationSize = 1)
	private Long idProperty;

	private String code;

	private String value;

	//bi-directional many-to-one association to ServiceInstance
    @ManyToOne
	@JoinColumn(name="id_service_instance")
	private ServiceInstance serviceInstance;

    public PropertyServiceInstance() {
    }
    
	public PropertyServiceInstance(ServiceInstance serviceInstance, String code, String value) {
		this.serviceInstance = serviceInstance;
		this.code = code;
		this.value = value;
	}

	public Long getIdProperty() {
		return this.idProperty;
	}

	public void setIdProperty(Long idProperty) {
		this.idProperty = idProperty;
	}

	public String getCode() {
		return this.code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getValue() {
		return this.value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public ServiceInstance getServiceInstance() {
		return this.serviceInstance;
	}

	public void setServiceInstance(ServiceInstance serviceInstance) {
		this.serviceInstance = serviceInstance;
	}
	
}