/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;


/**
 * The persistent class for the schema_metadata database table.
 * 
 */
@Entity
@Table(name="schema_metadata")
public class SchemaMetadata implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.TABLE)
	@Column(name="id_metadata")
	private String idMetadata;

    @Lob()
	@Column(name="data_schema")
	private String dataSchema;

    public SchemaMetadata() {
    }

	public String getIdMetadata() {
		return this.idMetadata;
	}

	public void setIdMetadata(String idMetadata) {
		this.idMetadata = idMetadata;
	}

	public String getDataSchema() {
		return this.dataSchema;
	}

	public void setDataSchema(String dataSchema) {
		this.dataSchema = dataSchema;
	}

}