/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;

/**
 * The primary key class for the step_rule database table.
 * 
 */
@Embeddable
public class StepRulePK implements Serializable {
	//default serial version id, required for serializable classes.
	private static final long serialVersionUID = 1L;

	@Column(name="id_step", insertable = false, updatable = false)
	private Long idStep;

	@Column(name="id_rule", insertable = false, updatable = false)
	private Long idRule;

    public StepRulePK() {
    }
	public Long getIdStep() {
		return this.idStep;
	}
	public void setIdStep(Long idStep) {
		this.idStep = idStep;
	}
	public Long getIdRule() {
		return this.idRule;
	}
	public void setIdRule(Long idRule) {
		this.idRule = idRule;
	}

	public boolean equals(Object other) {
		if (this == other) {
			return true;
		}
		if (!(other instanceof StepRulePK)) {
			return false;
		}
		StepRulePK castOther = (StepRulePK)other;
		return 
			this.idStep.equals(castOther.idStep)
			&& this.idRule.equals(castOther.idRule);

    }
    
	public int hashCode() {
		final int prime = 31;
		int hash = 17;
		hash = hash * prime + this.idStep.hashCode();
		hash = hash * prime + this.idRule.hashCode();
		
		return hash;
    }
}