/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;


/**
 * The persistent class for the sub_process database table.
 * 
 */
@Entity
@Table(name="sub_process")
public class SubProcess implements Serializable {
	private static final long serialVersionUID = 1L;

	@EmbeddedId
	private SubProcessPK id;

	private String descr;

	//bi-directional many-to-one association to Process
    @ManyToOne
	@JoinColumn(name="id_process")
	private Process process1;

	//bi-directional many-to-one association to Process
    @ManyToOne
	@JoinColumn(name="id_subprocess")
	private Process process2;

	//bi-directional many-to-one association to Step
    @ManyToOne
	@JoinColumn(name="id_step")
	private Step step;

    public SubProcess() {
    }

	public SubProcessPK getId() {
		return this.id;
	}

	public void setId(SubProcessPK id) {
		this.id = id;
	}
	
	public String getDescr() {
		return this.descr;
	}

	public void setDescr(String descr) {
		this.descr = descr;
	}

	public Process getProcess1() {
		return this.process1;
	}

	public void setProcess1(Process process1) {
		this.process1 = process1;
	}
	
	public Process getProcess2() {
		return this.process2;
	}

	public void setProcess2(Process process2) {
		this.process2 = process2;
	}
	
	public Step getStep() {
		return this.step;
	}

	public void setStep(Step step) {
		this.step = step;
	}
	
}