/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;

/**
 * The primary key class for the sub_process database table.
 * 
 */
@Embeddable
public class SubProcessPK implements Serializable {
	//default serial version id, required for serializable classes.
	private static final long serialVersionUID = 1L;

	@Column(name="id_process", updatable = false, insertable = false)
	private Long idProcess;

	@Column(name="id_step", updatable = false, insertable = false)
	private Long idStep;

	@Column(name="id_subprocess", updatable = false, insertable = false)
	private Long idSubprocess;

    public SubProcessPK() {
    }
	public Long getIdProcess() {
		return this.idProcess;
	}
	public void setIdProcess(Long idProcess) {
		this.idProcess = idProcess;
	}
	public Long getIdStep() {
		return this.idStep;
	}
	public void setIdStep(Long idStep) {
		this.idStep = idStep;
	}
	public Long getIdSubprocess() {
		return this.idSubprocess;
	}
	public void setIdSubprocess(Long idSubprocess) {
		this.idSubprocess = idSubprocess;
	}

	public boolean equals(Object other) {
		if (this == other) {
			return true;
		}
		if (!(other instanceof SubProcessPK)) {
			return false;
		}
		SubProcessPK castOther = (SubProcessPK)other;
		return 
			this.idProcess.equals(castOther.idProcess)
			&& this.idStep.equals(castOther.idStep)
			&& this.idSubprocess.equals(castOther.idSubprocess);

    }
    
	public int hashCode() {
		final int prime = 31;
		int hash = 17;
		hash = hash * prime + this.idProcess.hashCode();
		hash = hash * prime + this.idStep.hashCode();
		hash = hash * prime + this.idSubprocess.hashCode();
		
		return hash;
    }
}