/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;


/**
 * The persistent class for the transition database table.
 * 
 */
@Entity
@Table(name="transition")
public class Transition implements Serializable {
	private static final long serialVersionUID = 1L;

	@EmbeddedId
	private TransitionPK id;

	//bi-directional many-to-one association to Process
    @ManyToOne
	@JoinColumn(name="id_process")
	private Process process;

	//bi-directional many-to-one association to Step
    @ManyToOne
	@JoinColumn(name="id_step_source")
	private Step step1;

	//bi-directional many-to-one association to Step
    @ManyToOne
	@JoinColumn(name="id_step_target")
	private Step step2;

    public Transition() {
    }

	public TransitionPK getId() {
		return this.id;
	}

	public void setId(TransitionPK id) {
		this.id = id;
	}
	
	public Process getProcess() {
		return this.process;
	}

	public void setProcess(Process process) {
		this.process = process;
	}
	
	public Step getStep1() {
		return this.step1;
	}

	public void setStep1(Step step1) {
		this.step1 = step1;
	}
	
	public Step getStep2() {
		return this.step2;
	}

	public void setStep2(Step step2) {
		this.step2 = step2;
	}
	
}