/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;

/**
 * The primary key class for the transition database table.
 * 
 */
@Embeddable
public class TransitionPK implements Serializable {
	//default serial version id, required for serializable classes.
	private static final long serialVersionUID = 1L;

	@Column(name="id_step_source", updatable = false, insertable = false)
	private Long idStepSource;

	@Column(name="id_step_target", updatable = false, insertable = false)
	private Long idStepTarget;

    public TransitionPK() {
    }
	public Long getIdStepSource() {
		return this.idStepSource;
	}
	public void setIdStepSource(Long idStepSource) {
		this.idStepSource = idStepSource;
	}
	public Long getIdStepTarget() {
		return this.idStepTarget;
	}
	public void setIdStepTarget(Long idStepTarget) {
		this.idStepTarget = idStepTarget;
	}

	public boolean equals(Object other) {
		if (this == other) {
			return true;
		}
		if (!(other instanceof TransitionPK)) {
			return false;
		}
		TransitionPK castOther = (TransitionPK)other;
		return 
			this.idStepSource.equals(castOther.idStepSource)
			&& this.idStepTarget.equals(castOther.idStepTarget);

    }
    
	public int hashCode() {
		final int prime = 31;
		int hash = 17;
		hash = hash * prime + this.idStepSource.hashCode();
		hash = hash * prime + this.idStepTarget.hashCode();
		
		return hash;
    }
}