/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.model;

import java.io.Serializable;
import javax.persistence.*;
import java.util.List;


/**
 * The persistent class for the transition_state database table.
 * 
 */
@Entity
@Table(name="transition_state")
public class TransitionState implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.TABLE)
	@Column(name="id_state")
	private int idState;

	@Column(name="state_value")
	private String stateValue;

	//bi-directional many-to-one association to LogJournal
	@OneToMany(mappedBy="transitionState")
	private List<LogJournal> logJournals;

	//bi-directional many-to-one association to TransitionInstance
	@OneToMany(mappedBy="transitionState")
	private List<TransitionInstance> transitionInstances;

    public TransitionState() {
    }

	public int getIdState() {
		return this.idState;
	}

	public void setIdState(int idState) {
		this.idState = idState;
	}

	public String getStateValue() {
		return this.stateValue;
	}

	public void setStateValue(String stateValue) {
		this.stateValue = stateValue;
	}

	public List<LogJournal> getLogJournals() {
		return this.logJournals;
	}

	public void setLogJournals(List<LogJournal> logJournals) {
		this.logJournals = logJournals;
	}
	
	public List<TransitionInstance> getTransitionInstances() {
		return this.transitionInstances;
	}

	public void setTransitionInstances(List<TransitionInstance> transitionInstances) {
		this.transitionInstances = transitionInstances;
	}
	
}