/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.metadb.utils;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.xml.namespace.QName;

import org.eclipse.ebpm.metadb.constants.RuleMepStateConstants;
import org.eclipse.ebpm.metadb.constants.TransitionStateConstants;
import org.eclipse.ebpm.metadb.model.PoolType;
import org.eclipse.ebpm.metadb.model.ProcessInstance;
import org.eclipse.ebpm.metadb.model.TransitionInstance;
import org.eclipse.ebpm.metadb.model.TransitionState;

public class AuditDBUtils {

	public static final String PROCESS_PROC_ID = "idProcess".intern();
	public static final String PROCESS_NAME = "name".intern();
	public static final String PROCESS_TYPE_SERVICE = "typeService".intern();
	public static final String PROCESS = "process.".intern();

	public static final String STEP_NAME = "name".intern();
	public static final String STEP_ID = "idStep".intern();

	public static final String PROCESS_INSTANCE_PROC_INSTANCE_ID = "idProcessInstance".intern();
	public static final String PROCESS_INSTANCE_ID_CORRELATION = "idCorrelation".intern();
	public static final String PROCESS_INSTANCE_ID_POOL = "idPool".intern();
	public static final String PROCESS_INSTANCE_STATE = "state".intern();

	public static final String TRANSITION_INSTANCE_ID = "idJournal".intern();
	public static final String TRANSITION_INSTANCE_PROC_INSTANCE = "processInstance.".intern();
	public static final String TRANSITION_INSTANCE_TARGET_STEP = "stepByIdStepTarget.".intern();
	
	public static final String VARIABLE_INSTANCE_ID = "idVariableInstance".intern();
	public static final String VARIABLE_DEFINITION_ID = "idVariableDefinition".intern();
	public static final String VARIABLE_NAME = "name".intern();
	public static final String VARIABLE_PROCESS_INSTANCE = "processInstance.".intern();

//	public static Boolean existTransitionBySourceIDAndTargetID(Session aSession, String idSource, String idTarget) {
//		return ((Long) (aSession
//				.createQuery(
//						"select count(*) from org.spagic.metadb.model.Transition as t where t.id.idStepSource= :ID_SOURCE and t.id.idStepTarget= :ID_TARGET")
//				.setString("ID_SOURCE", idSource).setString("ID_TARGET", idTarget).uniqueResult()) > 0);
//	}
//
//	public static TransitionInstance getTransitionInstanceByMessageId(Session aSession, String idMessage) {
//		Criteria aCriteria = aSession.createCriteria(TransitionInstance.class);
//		aCriteria.add(Expression.eq("idMessage", idMessage));
//		return (TransitionInstance) aCriteria.uniqueResult();
//	}
//
//	public static TransitionInstance getTransitionInstanceById(Session aSession, long idJournal) {
//		Criteria aCriteria = aSession.createCriteria(TransitionInstance.class);
//		aCriteria.add(Expression.eq(TRANSITION_INSTANCE_ID, idJournal));
//		return (TransitionInstance) aCriteria.uniqueResult();
//	}
//
//	public static List<TransitionInstance> getTransitionInstancesByProcessInstanceIdAndTargetStep(Session aSession,
//			long idProcessInstance, long idStep) {
//		Criteria aCriteria = aSession.createCriteria(TransitionInstance.class);
//		aCriteria.add(Expression.eq(TRANSITION_INSTANCE_PROC_INSTANCE + PROCESS_INSTANCE_PROC_INSTANCE_ID,
//				idProcessInstance));
//		aCriteria.add(Expression.eq(TRANSITION_INSTANCE_TARGET_STEP + STEP_ID, idStep));
//		// Order the result by transitionInstance id: DONT REMOVE THIS, SOME METHODS
//		// RELY ON IT
//		aCriteria.addOrder(Order.asc(TRANSITION_INSTANCE_ID));
//		return (List<TransitionInstance>) aCriteria.list();
//	}
//
//	public static List<TransitionInstance> getTransitionInstancesActiveJbpm(Session aSession, long processInstanceId) {
//		Criteria aCriteria = aSession.createCriteria(TransitionInstance.class);
//		aCriteria.add(Expression.eq("processInstance.idProcessInstance", processInstanceId)).add(
//				Restrictions.in("transitionState.idState", new Integer[] { TransitionStateConstants.JBPM_AVAILABLE_ACTIVITY }))
//				.addOrder(Order.asc("transitionStart"));
//		return (List<TransitionInstance>) aCriteria.list();
//	}
//
//	public static List getTransitionInstancesActive(Session aSession, long processInstanceId) {
//		Criteria aCriteria = aSession.createCriteria(TransitionInstance.class);
//		aCriteria.add(Expression.eq("processInstance.idProcessInstance", processInstanceId)).add(
//				Restrictions.in("transitionState.idState", new Integer[] { TransitionStateConstants.JBI_MEP_INONLY_ACTIVE,
//						TransitionStateConstants.JBI_MEP_INOPTIONALOUT_ACTIVE, TransitionStateConstants.JBI_MEP_INOUT_ACTIVE,
//						TransitionStateConstants.JBI_MEP_ROBUSTINONLY_ACTIVE })).addOrder(Order.asc("transitionStart"));
//		return (List<TransitionInstance>) aCriteria.list();
//		// String hql =
//		// "select ji.idJournal from org.spagic.metadb.model.TransitionInstance ji "
//		// +
//		// " where ji.processInstance.idProcessInstance = :pProcessInstance and ji.transitionState.idState in ("
//		// +
//		// TransitionStateConstants.JBI_MEP_INONLY_ACTIVE+","+
//		// TransitionStateConstants.JBI_MEP_INOPTIONALOUT_ACTIVE +"," +
//		// TransitionStateConstants.JBI_MEP_INOUT_ACTIVE+ ","+
//		// TransitionStateConstants.JBI_MEP_ROBUSTINONLY_ACTIVE + ")" +
//		// " order by transition_start asc";
//		// Query aQuery = aSession.createQuery(hql);
//		// aQuery.setLong("pProcessInstance",
//		// processInstance.getIdProcessInstance());
//		// return aQuery.list();
//	}
//
//	public static long getTransitionInstancesNotClosed(Session aSession, ProcessInstance processInstance) {
//		String hql = "select count(ji.idJournal) from org.spagic.metadb.model.TransitionInstance ji "
//				+ " where ji.processInstance.idProcessInstance = :pProcessInstance and ji.transitionState.idState not in ("
//				+ TransitionStateConstants.JBI_MEP_INONLY_DONE + "," + TransitionStateConstants.JBI_MEP_INOPTIONALOUT_DONE
//				+ "," + TransitionStateConstants.JBI_MEP_INOUT_DONE + "," + TransitionStateConstants.JBI_MEP_ROBUSTINONLY_DONE
//				+ "," + TransitionStateConstants.JBI_MEP_INOUT_FAULT + ")";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setLong("pProcessInstance", processInstance.getIdProcessInstance());
//		Long uniqueResult = null;
//		Object result = aQuery.uniqueResult();
//		// some hibernate version return Integer instead of Long
//		if (result instanceof Integer) {
//			uniqueResult = ((Integer) result).longValue();
//		} else {
//			uniqueResult = (Long) result;
//		}
//		return uniqueResult;
//	}
//
//	public static long getTransitionInstancesWarning(Session aSession, ProcessInstance processInstance) {
//		String hql = "select count(ji.idJournal) from org.spagic.metadb.model.TransitionInstance ji "
//				+ " where ji.processInstance.idProcessInstance = :pProcessInstance and ji.runtimeWarning=true";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setLong("pProcessInstance", processInstance.getIdProcessInstance());
//		Long uniqueResult = null;
//		Object result = aQuery.uniqueResult();
//		// some hibernate version return Integer instead of Long
//		if (result instanceof Integer) {
//			uniqueResult = ((Integer) result).longValue();
//		} else {
//			uniqueResult = (Long) result;
//		}
//		return uniqueResult;
//	}
//
//	public static ProcessInstance getProcessInstanceByIdCorrelation(Session aSession, String idCorrelation) {
//		Criteria aCriteria = aSession.createCriteria(ProcessInstance.class);
//		aCriteria.add(Expression.eq(PROCESS_INSTANCE_ID_CORRELATION, idCorrelation));
//		return (ProcessInstance) aCriteria.uniqueResult();
//	}
//
//	public static List<ProcessInstance> getProcessInstancesByIdPool(Session aSession, Long idPool) {
//		Criteria aCriteria = aSession.createCriteria(ProcessInstance.class);
//		aCriteria.add(Expression.eq(PROCESS_INSTANCE_ID_POOL, idPool));
//		return (List<ProcessInstance>) aCriteria.list();
//	}
//
//	public static ProcessInstance getProcessInstanceById(Session aSession, long idInstance) {
//		Criteria aCriteria = aSession.createCriteria(ProcessInstance.class);
//		aCriteria.add(Expression.eq(PROCESS_INSTANCE_PROC_INSTANCE_ID, idInstance));
//		return (ProcessInstance) aCriteria.uniqueResult();
//	}
//	
//	public static List<Step> getStepList(Session aSession, long idProcess) {
//		Criteria aCriteria = aSession.createCriteria(Step.class);
//		aCriteria.add(Expression.eq("process.idProcess", idProcess));
//		aCriteria.addOrder(Order.asc("name"));
//
//		return (List<Step>)aCriteria.list();
//	}	
//
//	public static Process getProcessById(Session aSession, long idProcess) {
//		Criteria aCriteria = aSession.createCriteria(Process.class);
//		aCriteria.add(Expression.eq(PROCESS_PROC_ID, idProcess));
//		return (Process) aCriteria.uniqueResult();
//	}
//
//	public static Step getStepByName(Session aSession, String stepName) {
//		Step step = null;
//		Criteria aCriteria = aSession.createCriteria(Step.class);
//		aCriteria.add(Expression.eq(STEP_NAME, stepName));
//		step = (Step) aCriteria.uniqueResult();
//		return step;
//	}
//
//	public static Step getStepByNameAndVersion(Session aSession, String qName, String stepName, long version) {
//		Step step = null;
//		Criteria aCriteria = aSession.createCriteria(Step.class);
//		aCriteria.add(Expression.eq("namespace", qName));
//		aCriteria.add(Expression.eq(STEP_NAME, stepName));
//		aCriteria.add(Expression.eq("processVersion", version));
//		step = (Step) aCriteria.uniqueResult();
//		return step;
//	}
//
//	// public static Step getStepByName(Session aSession, String qName, String
//	// stepName) {
//	// String hql =
//	// "select max(step.processVersion) from org.spagic.metadb.model.Step step " +
//	// " where step.namespace = :pnamespace and step.name = :pname";
//	// Query aQuery = aSession.createQuery(hql);
//	// aQuery.setString("pnamespace", qName);
//	// aQuery.setString("pname", stepName);
//	// Long maxVersion = (Long)aQuery.uniqueResult();
//	// if (maxVersion == null){
//	// return null;
//	// }
//	// return getStepByNameAndVersion(aSession, qName, stepName, maxVersion);
//	// }
//	public static Step getStepByName(Session aSession, String namespace, String stepName) {
//		Step step = null;
//		Criteria aCriteria = aSession.createCriteria(Step.class);
//		aCriteria.add(Expression.eq("namespace", namespace));
//		aCriteria.add(Expression.eq(STEP_NAME, stepName));
//		step = (Step) aCriteria.uniqueResult();
//		return step;
//	}
//
//	/**
//	 * The identifier of MEP state stored in the RULE table doesnt map directly to
//	 * the JBI MEP states. This method allows mapping between the two codings.
//	 * 
//	 * @param ruleMepState
//	 *          MEP state as stored in RULES table (IN, OUT, INOUT)
//	 * @param state
//	 *          JBI MEP state
//	 * @return true if the two states are compatibles.
//	 */
//	private static boolean mapRuleMEPStateToMepState(int ruleMepState, TransitionState state) {
//
//		final int[] NO_VALUES = {};
//		final int[] IN_VALUES = { TransitionStateConstants.JBI_MEP_INONLY_ACTIVE,
//				TransitionStateConstants.JBI_MEP_INOUT_ACTIVE, TransitionStateConstants.JBI_MEP_ROBUSTINONLY_ACTIVE,
//				TransitionStateConstants.JBI_MEP_INOPTIONALOUT_ACTIVE, TransitionStateConstants.BPEL_START_ACTIVITY,
//				TransitionStateConstants.BPEL_END_ACTIVITY, TransitionStateConstants.BPEL_FAULTED_ACTIVITY ,
//				TransitionStateConstants.JBPM_DONE_ACTIVITY, TransitionStateConstants.JBPM_FAULTED_ACTIVITY};
//		// final int[] OUT_VALUES = {
//		// TransitionStateConstants.JBI_MEP_INOUT_OUT,
//		// TransitionStateConstants.JBI_MEP_INOPTIONALOUT_STEP1_OUT};
//		// final int[] INOUT_VALUES = {
//		// // IN values
//		// TransitionStateConstants.JBI_MEP_INONLY_ACTIVE,
//		// TransitionStateConstants.JBI_MEP_INOUT_ACTIVE,
//		// TransitionStateConstants.JBI_MEP_ROBUSTINONLY_ACTIVE,
//		// TransitionStateConstants.JBI_MEP_INOPTIONALOUT_ACTIVE,
//		// // OUT values
//		// TransitionStateConstants.JBI_MEP_INOUT_OUT,
//		// TransitionStateConstants.JBI_MEP_INOPTIONALOUT_STEP1_OUT};
//
//		int[] valueList = NO_VALUES;
//
//		switch (ruleMepState) {
//		case RuleMepStateConstants.INPUT_MESSAGES:
//			valueList = IN_VALUES;
//			break;
//		// Not supported anymore
//		// case RuleMepStateConstants.JBI_MEP_OUT:
//		// valueList = OUT_VALUES;
//		// break;
//		// case RuleMepStateConstants.JBI_MEP_IN_OUT:
//		// valueList = INOUT_VALUES;
//		// break;
//		}
//
//		for (int i = 0; i < valueList.length; i++) {
//			if (valueList[i] == state.getIdState()) {
//				return true;
//			}
//		}
//		return false;
//	}
//
//	/**
//	 * Retrieve all Rule configured for the given endpoint
//	 * 
//	 * @param aSession
//	 *          Hibernate session
//	 * @param step
//	 *          Starting endpoint
//	 * @param state
//	 *          MEP state to check for
//	 * @return Collection of Rule
//	 */
//	@SuppressWarnings("unchecked")
//	public static Collection<Rule> getRulesByStep(Session aSession, Step step, TransitionState state) {
//		List<Rule> result = new ArrayList<Rule>();
//
//		Set endPoints = step.getStepRules();
//		// Verify that endpoints satisfy some criteria
//		Date currentDate = new Date();
//		for (Iterator it = endPoints.iterator(); it.hasNext();) {
//			StepRule endPointRule = (StepRule) it.next();
//			Rule currentRule = endPointRule.getRule();
//
//			if (!mapRuleMEPStateToMepState(currentRule.getTransitionState(), state)) {
//				it.remove();
//				continue;
//			}
//
//			// Verify that startDate <= currentDate <= endDate
//			if ((currentRule.getStartDate() != null) && currentRule.getStartDate().after(currentDate)) {
//				it.remove();
//				continue;
//			}
//			if ((currentRule.getEndDate() != null) && currentRule.getEndDate().before(currentDate)) {
//				it.remove();
//				continue;
//			}
//			result.add(currentRule);
//		}
//		return result;
//	}
//
//	/**
//	 * Retrieves a rule by name
//	 * 
//	 * @param aSession
//	 *          Hibernate session
//	 * @param ruleName
//	 *          Rule name
//	 * @return The unique rule with the specified name
//	 */
//	public static Rule getRuleByName(Session aSession, String ruleName) {
//		Criteria aCriteria = aSession.createCriteria(Rule.class);
//		aCriteria.add(Expression.eq("name", ruleName));
//		return (Rule) aCriteria.uniqueResult();
//	}
//
//	/**
//	 * Retrieves a catalog by name
//	 * 
//	 * @param aSession
//	 *          Hibernate session
//	 * @param ruleName
//	 *          Rule name
//	 * @return The unique rule with the specified name
//	 */
//	public static Catalog getCatalogByName(Session aSession, String catalogName) {
//		Criteria aCriteria = aSession.createCriteria(Catalog.class);
//		aCriteria.add(Expression.eq("name", catalogName));
//		return (Catalog) aCriteria.uniqueResult();
//	}
//
//	@SuppressWarnings("unchecked")
//	public static List<PoolType> getIterTypes(Session aSession) throws Exception {
//		Criteria aCriteria = aSession.createCriteria(PoolType.class);
//		return aCriteria.list();
//	}
//
//	@SuppressWarnings("unchecked")
//	public static List<RelevantData> getRelevantDataByValue(String dataValue, long idAttribute,
//			long excludeRelevantDataId, Session aSession) throws Exception {
//		Criteria aCriteria = aSession.createCriteria(RelevantData.class);
//		aCriteria.add(Expression.eq("value", dataValue));
//		aCriteria.add(Expression.eq("attribute.idAttribute", idAttribute));
//		aCriteria.add(Expression.ne("idRelevantData", excludeRelevantDataId));
//		return aCriteria.list();
//	}
//
//	// Get all the iter type that have in the definition the Service Assembly of
//	// this instance
//	public static List<PoolType> getCandidateIterTypesForProcess(Process process, Session aSession) {
//		String hql = "select i.poolType from org.spagic.metadb.model.PoolTypeProcess i where i.id.idProcess = "
//				+ process.getIdProcess();
//		return aSession.createQuery(hql).list();
//	}
//
//	public static boolean isFirstProcessInIterType(Process process, PoolType iterType, Session aSession) {
//		PoolTypeProcessId ptProcessId = new PoolTypeProcessId(process.getIdProcess(), iterType.getIdPoolType());
//		PoolTypeProcess poolTypeProcess = (PoolTypeProcess) aSession.get(PoolTypeProcess.class, ptProcessId);
//
//		if (poolTypeProcess == null)
//			return false;
//
//		return (poolTypeProcess.getOrderCriteria() == 1);
//	}
//
//	public static List<Attribute> getAttributeForIterType(PoolType iterType, Session aSession) {
//		String hql = "select i.attribute from org.spagic.metadb.model.AttributePool i where i.id.idPoolType = "
//				+ iterType.getIdPoolType() + " order by i.attribute.idAttribute";
//		return aSession.createQuery(hql).list();
//	}
//
//	public static PoolInstance getPoolInstanceByUniqueKey(String poolInstanceKey, PoolType poolType, Session aSession) {
//		Criteria aCriteria = aSession.createCriteria(PoolInstance.class);
//		aCriteria.add(Expression.eq("uniquePoolInstanceKey", poolInstanceKey));
//		aCriteria.add(Expression.eq("poolType.idPoolType", poolType.getIdPoolType()));
//		return (PoolInstance) aCriteria.uniqueResult();
//	}
//
//	//
//	// Get the last version number of the Service Assembly named with name.
//	//
//	public static String getCurrentProcessVersion(String processName, Session aSession) {
//		String subHql = "select max(process.idProcess) from org.spagic.metadb.model.Process process where process.name = :pname ";
//		String hql = "select process.processVersion from org.spagic.metadb.model.Process process where process.idProcess in ("
//				+ subHql + ")";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setString("pname", processName);
//		String processVersion = (String) aQuery.uniqueResult();
//		return processVersion;
//	}
//
//	public static TypeService getTypeServiceById(Session aSession, long idType) {
//		Criteria aCriteria = aSession.createCriteria(TypeService.class);
//		aCriteria.add(Expression.eq("idTs", idType));
//		return (TypeService) aCriteria.uniqueResult();
//	}
//
//	public static Process getProcessByQNameAndVersion(Session aSession, QName processQName, String processVersion) {
//		Criteria aCriteria = aSession.createCriteria(Process.class);
//		aCriteria.add(Expression.eq("namespace", processQName.getNamespaceURI()));
//		aCriteria.add(Expression.eq(PROCESS_NAME, processQName.getLocalPart()));
//		aCriteria.add(Expression.eq("processVersion", processVersion));
//		return (Process) aCriteria.uniqueResult();
//	}
//
//	public static Process getProcessByNameAndVersion(Session aSession, String processName, String processVersion) {
//		Criteria aCriteria = aSession.createCriteria(Process.class);
//		aCriteria.add(Expression.eq(PROCESS_NAME, processName));
//		aCriteria.add(Expression.eq("processVersion", processVersion));
//		return (Process) aCriteria.uniqueResult();
//	}
//
//	public static org.spagic.metadb.model.Process getLastDefinitionForProcess(Session aSession, String processName) {
//
//		String lastVersion = AuditDBUtils.getCurrentProcessVersion(processName, aSession);
//		org.spagic.metadb.model.Process metaDBProcess = AuditDBUtils.getProcessByNameAndVersion(aSession, processName,
//				lastVersion);
//		return metaDBProcess;
//
//	}
//
//	public static List<Process> getAllLatestDefinitionProcesses(Session aSession) {
//		String hql = "select max(p.idProcess) from Process p group by p.name";
//
//		List<Long> processListIdGroupedByName = aSession.createQuery(hql).list();
//
//		List<Process> result = new ArrayList<Process>();
//
//		for (Long id : processListIdGroupedByName)
//			result.add((Process) aSession.get(Process.class, id));
//		return result;
//	}
//
//	public static void deleteAttribute(Session aSession, Attribute attribute) {
//
//		String hql = " from org.spagic.metadb.model.AttributeCatalog ac where ac.id.idAttribute = "
//				+ attribute.getIdAttribute();
//		List<AttributeCatalog> attributeCatalogRel = aSession.createQuery(hql).list();
//
//		for (AttributeCatalog attCatalog : attributeCatalogRel) {
//			aSession.delete(attCatalog);
//			aSession.flush();
//		}
//
//		aSession.delete(attribute);
//		aSession.flush();
//	}
//
//	public static void deleteCatalog(Session aSession, Catalog catalog) {
//		// Remove the relations of this catlaog withn attributes
//
//		List<AttributeCatalog> attributeCatalogRel = getAttributeCatalogRelationExtentForCatalog(aSession, catalog);
//		for (AttributeCatalog attCatalog : attributeCatalogRel) {
//			aSession.delete(attCatalog);
//			aSession.flush();
//		}
//		aSession.delete(catalog);
//		aSession.flush();
//	}
//
//	public static Attribute getAttributeByName(Session aSession, String attributeName) {
//		Criteria crit = aSession.createCriteria(Attribute.class);
//		crit.add(Expression.eq("name", attributeName));
//		Attribute anAttribute = (Attribute) crit.uniqueResult();
//		return anAttribute;
//	}
//
//	public static List<AttributeCatalog> getAttributeCatalogRelationExtentForCatalog(Session aSession, Catalog catalog) {
//		String hql = " from org.spagic.metadb.model.AttributeCatalog ac where ac.id.idCatalog = " + catalog.getIdCatalog()
//				+ " order by ac.orderCriteria";
//		return aSession.createQuery(hql).list();
//	}
//
//	public static Object getObjectById(Session aSession, Class clazz, Serializable id) {
//		return aSession.get(clazz, id);
//	}
//
//	public static List<Rule> getRelevantDataRules(Session aSession) {
//		String hql = "from org.spagic.metadb.model.Rule r where r.ruleUsage = 0";
//		return aSession.createQuery(hql).list();
//	}
//
//	public static TypeService getTypeServiceWithValue(Session aSession, String typeServiceValue) {
//		Criteria crit = aSession.createCriteria(TypeService.class);
//		crit.add(Expression.eq("value", typeServiceValue));
//		TypeService ts = (TypeService) crit.uniqueResult();
//		return ts;
//	}
//
//	public static List<XmlNamespace> getXmlNamespaces(Session aSession) {
//		String hql = "from org.spagic.metadb.model.XmlNamespace";
//		return aSession.createQuery(hql).list();
//	}
//
//	public static void linkAttributeToCatalog(Session aSession, Attribute attribute, Catalog catalog) {
//		String hql = "select max(i.orderCriteria) from org.spagic.metadb.model.AttributeCatalog i where i.id.idCatalog = "
//				+ catalog.getIdCatalog();
//		Integer maxPos = (Integer) aSession.createQuery(hql).uniqueResult();
//		if (maxPos == null)
//			maxPos = 0;
//
//		AttributeCatalogId aAttributeCatalogId = new AttributeCatalogId(attribute.getIdAttribute(), catalog.getIdCatalog());
//		AttributeCatalog aAttributeCatalog = new AttributeCatalog(aAttributeCatalogId, catalog, attribute, true, maxPos + 1);
//		aSession.save(aAttributeCatalog);
//		aSession.flush();
//	}
//
//	public static void unlinkAttributeToCatalog(Session aSession, Attribute attribute, Catalog catalog) {
//		AttributeCatalogId aAttributeCatalogId = new AttributeCatalogId(attribute.getIdAttribute(), catalog.getIdCatalog());
//		AttributeCatalog attributeCatalog = (AttributeCatalog) getObjectById(aSession, AttributeCatalog.class,
//				aAttributeCatalogId);
//		aSession.delete(attributeCatalog);
//		aSession.flush();
//	}
//
//	public static XmlNamespace storeXmlNamespace(Session aSession, XmlNamespace aXmlNamespace) {
//		aSession.save(aXmlNamespace);
//		aSession.flush();
//		return aXmlNamespace;
//	}
//
//	public static XmlNamespace getNamespaceByPrefix(Session aSession, String prefix) {
//		Criteria criteria = aSession.createCriteria(XmlNamespace.class).add(Expression.eq("prefix", prefix));
//		return (XmlNamespace) criteria.uniqueResult();
//	}
//
//	public static void deleteXmlNamespace(Session aSession, XmlNamespace aXmlNamespace) {
//		aSession.delete(aXmlNamespace);
//		aSession.flush();
//	}
//
//	public static List<Attribute> getAttributesForCatalog(Session aSession, Catalog catalog) {
//		String hql = " select ac.attribute from org.spagic.metadb.model.AttributeCatalog ac where ac.id.idCatalog = "
//				+ catalog.getIdCatalog();
//		List<Attribute> result = aSession.createQuery(hql).list();
//		return result;
//	}
//
//	public static List<Catalog> getCatalogs(Session aSession) {
//		String hql = "from org.spagic.metadb.model.Catalog";
//		List<Catalog> result = aSession.createQuery(hql).list();
//		return result;
//	}
//
//	public static Catalog storeCatalog(Session aSession, Catalog catalog) {
//		return (Catalog) genericStore(aSession, catalog);
//	}
//
//	public static Attribute storeAttribute(Session aSession, Attribute attribute) {
//		return (Attribute) genericStore(aSession, attribute);
//	}
//
//	public static List<Rule> getRules(Session aSession) {
//		String hql = "from org.spagic.metadb.model.Rule";
//		return aSession.createQuery(hql).list();
//	}
//
//	public static Rule storeRule(Session aSession, Rule aRule) {
//		return (Rule) genericStore(aSession, aRule);
//	}
//
//	public static Object genericStore(Session aSession, Object object) {
//		aSession.save(object);
//		aSession.flush();
//		return object;
//	}
//
//	public static List<Attribute> getAttributes(Session aSession) {
//		String hql = "from org.spagic.metadb.model.Attribute";
//		return aSession.createQuery(hql).list();
//	}
//
//	public static void linkRuleToStep(Session aSession, Rule rule, Step step) {
//		StepRuleId stepRuleId = new StepRuleId(step.getIdStep(), rule.getIdRule());
//		StepRule stepRule = new StepRule(stepRuleId, step, rule, 0);
//		aSession.save(stepRule);
//		aSession.flush();
//	}
//
//	public static void unlinkRuleToStep(Session aSession, Rule rule, Step step) {
//		StepRuleId stepRuleId = new StepRuleId(step.getIdStep(), rule.getIdRule());
//		StepRule stepRule = (StepRule) aSession.get(StepRule.class, stepRuleId);
//		aSession.delete(stepRule);
//		aSession.flush();
//	}
//
//	public static ProcessDiagram getProcessDiagram(Session aSession, Process process) {
//		return (ProcessDiagram) getObjectById(aSession, ProcessDiagram.class, process.getIdProcess());
//	}
//
//	public static boolean isAttributeLinkedToCatalog(Session aSession, Attribute attribute, Catalog catalog) {
//
//		AttributeCatalogId aAttributeCatalogId = new AttributeCatalogId(attribute.getIdAttribute(), catalog.getIdCatalog());
//		AttributeCatalog attCatalog = (AttributeCatalog) aSession.get(AttributeCatalog.class, aAttributeCatalogId);
//		return (attCatalog != null);
//
//	}
//
//	// public static boolean isOracle(Session aSession) {
//	// String oracleName = OracleDialect.class.getName();
//	// String currentDialectName =
//	// ((SessionFactoryImplementor)aSession.getSessionFactory()).getDialect().getClass().getName();
//	//		
//	// return oracleName.equalsIgnoreCase(currentDialectName);
//	// }
//
//	public static List<Process> getAllProcesses(Session aSession) {
//		String hql = "from org.spagic.metadb.model.Process p order by p.name, p.processVersion";
//		return aSession.createQuery(hql).list();
//
//	}
//
//	public static List<String> getAllProcessesForTechnology(Session aSession, String technologyName) {
//		String hql = "select distinct p.name from org.spagic.metadb.model.Process p  where p.typeService.value = :pTec order by p.name";
//
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setString("pTec", technologyName);
//
//		return aQuery.list();
//
//	}
//
//	public static Property getStepPropertyByName(Session aSession, Step step, String propertyName) {
//
//		String hql = "select ps.property from org.spagic.metadb.model.PropertyStep ps where ps.step.idStep = :pIdStep and ps.property.code = :pName";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setLong("pIdStep", step.getIdStep());
//		aQuery.setString("pName", propertyName);
//
//		return (Property) aQuery.uniqueResult();
//	}
//
//	/**
//	 * Retrieves a PoolType by name
//	 * 
//	 * @param aSession
//	 *          Hibernate session
//	 * @param poolTypeName
//	 *          PoolType name
//	 * @return The unique PoolType with the specified name
//	 */
//	public static PoolType getPoolTypeByName(Session aSession, String poolTypeName) {
//		Criteria aCriteria = aSession.createCriteria(PoolType.class);
//		aCriteria.add(Expression.eq("name", poolTypeName));
//		return (PoolType) aCriteria.uniqueResult();
//	}
//
//	public static List<Process> getProcessesFilteredByPropertyName(Session aSession, String propertyName,
//			String propertyValue) {
//		String hql = "select pp.process from org.spagic.metadb.model.PropertyProcess pp "
//				+ "where pp.property.code = :pCode " + "and pp.property.value = :pValue";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setString("pCode", propertyName);
//		aQuery.setString("pValue", propertyValue);
//
//		return aQuery.list();
//	}
//
//	public static Step getNamedStepForProcess(Session aSession, Long idProcess, String stepName) {
//		Step step = null;
//		Criteria aCriteria = aSession.createCriteria(Step.class);
//		aCriteria.add(Expression.eq(STEP_NAME, stepName));
//		aCriteria.add(Expression.eq("process." + PROCESS_PROC_ID, idProcess));
//		step = (Step) aCriteria.uniqueResult();
//		return step;
//	}
//
//	public static List<Property> getStepPropertyWithNameLike(Session aSession, Step step, String nameLike) {
//
//		String hql = "select ps.property from org.spagic.metadb.model.PropertyStep ps where ps.step.idStep = :pIdStep and ps.property.code like :pName";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setLong("pIdStep", step.getIdStep());
//		aQuery.setString("pName", nameLike + '%');
//		return aQuery.list();
//
//	}
//
//	public static List<Property> getProcessPropertyWithNameLike(Session aSession, Process process, String nameLike) {
//
//		String hql = "select pp.property from org.spagic.metadb.model.PropertyProcess pp where pp.process.idProcess = :pIdProcess and pp.property.code like :pName";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setLong("pIdProcess", process.getIdProcess());
//		aQuery.setString("pName", nameLike + '%');
//		return aQuery.list();
//
//	}
//
//	public static List<Property> getProcessProperty(Session aSession, Long idProcess) {
//		String hql = "select pp.property from org.spagic.metadb.model.PropertyProcess pp where pp.process.idProcess = :pIdProcess";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setLong("pIdProcess", idProcess);
//		return (List<Property>)aQuery.list();
//	}
//
//	public static Property getProcessProperty(Session aSession, Process process, String name) {
//		if (process == null)
//			return null;
//		String hql = "select pp.property from org.spagic.metadb.model.PropertyProcess pp where pp.process.idProcess = :pIdProcess and pp.property.code like :pName";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setLong("pIdProcess", process.getIdProcess());
//		aQuery.setString("pName", name);
//		return (Property) aQuery.uniqueResult();
//
//	}
//
//	public static List<ProcessInstance> getProcessInstancesForProcess(Session aSession, long processId) {
//		Criteria aCriteria = aSession.createCriteria(ProcessInstance.class);
//		aCriteria.add(Expression.eq("process." + PROCESS_PROC_ID, processId));
//		return (List<ProcessInstance>) aCriteria.list();
//
//	}
//
//	public static List<ProcessInstance> getAllProcessInstances(Session aSession) {
//		String hql = "from org.spagic.metadb.model.ProcessInstance";
//		Query aQuery = aSession.createQuery(hql);
//		return (List<ProcessInstance>) aQuery.list();
//	}
//
//	public static List<ProcessInstance> getAllProcessInstancesByTechnology(Session aSession, long technology) {
//		String hql = "from org.spagic.metadb.model.ProcessInstance pi where pi.process." + PROCESS_TYPE_SERVICE
//				+ ".idTs = :technology";
//		Query aQuery = aSession.createQuery(hql);
//		aQuery.setLong("technology", technology);
//		return (List<ProcessInstance>) aQuery.list();
//	}
//	
//	public static Set<VariableInstance> getProcessInstanceVariableList(Session aSession, long idProcessInstance) {
//		Criteria aCriteria = aSession.createCriteria(ProcessInstance.class);
//		aCriteria.add(Expression.eq(PROCESS_INSTANCE_PROC_INSTANCE_ID, idProcessInstance));
//		ProcessInstance pi = (ProcessInstance)aCriteria.uniqueResult();
//		Set<VariableInstance> result = pi.getVariableInstances();
//		return result;
//	}
//	
//	public static Set<VariableDefinition> getProcessVariableList(Session aSession, long idProcess) {
//		Criteria aCriteria = aSession.createCriteria(Process.class);
//		aCriteria.add(Expression.eq(PROCESS_PROC_ID, idProcess));
//		Process process = (Process)aCriteria.uniqueResult();
//		Set<VariableDefinition> result = process.getVariableDefinitions();
//		return result;
//	}
//	
//	public static VariableInstance getProcessInstanceVariableInstance(Session aSession, long idProcessInstance, long idVariableInstance) {
//		Criteria aCriteria = aSession.createCriteria(VariableInstance.class);
//		aCriteria.add(Expression.eq(VARIABLE_INSTANCE_ID , idVariableInstance));
//		aCriteria.add(Expression.eq(TRANSITION_INSTANCE_PROC_INSTANCE + PROCESS_INSTANCE_PROC_INSTANCE_ID, idProcessInstance));
//		return (VariableInstance) aCriteria.uniqueResult();
//	}
//	
//	public static List<VariableInstance> getAllProcessInstanceVariableInstances(Session aSession, long idProcessInstance) {
//		Criteria aCriteria = aSession.createCriteria(VariableInstance.class);
//		aCriteria.add(Expression.eq(TRANSITION_INSTANCE_PROC_INSTANCE + PROCESS_INSTANCE_PROC_INSTANCE_ID, idProcessInstance));
//		return (List<VariableInstance>) aCriteria.list();
//	}
//	
//	public static VariableDefinition getVariableDefinition(Session aSession, long idProcess, long idVariableDefinition) {
//		Criteria aCriteria = aSession.createCriteria(VariableDefinition.class);
//		aCriteria.add(Expression.eq(PROCESS + PROCESS_PROC_ID, idProcess));
//		aCriteria.add(Expression.eq(VARIABLE_DEFINITION_ID, idVariableDefinition));
//		return (VariableDefinition) aCriteria.uniqueResult();
//	}
//	
//	public static VariableDefinition getVariableDefinition(Session aSession, long idProcess, String variableName) {
//		Criteria aCriteria = aSession.createCriteria(VariableDefinition.class);
//		aCriteria.add(Expression.eq(PROCESS + PROCESS_PROC_ID, idProcess));
//		aCriteria.add(Expression.eq(VARIABLE_NAME, variableName));
//		return (VariableDefinition) aCriteria.uniqueResult();
//	}
//	
//	public static VariableInstance getVariableInstance(Session aSession, long idProcessInstance, String variableName) {
//		Criteria aCriteria = aSession.createCriteria(VariableInstance.class);
//		aCriteria.add(Expression.eq(VARIABLE_PROCESS_INSTANCE + PROCESS_INSTANCE_PROC_INSTANCE_ID, idProcessInstance));
//		aCriteria.add(Expression.eq(VARIABLE_NAME, variableName));
//		return (VariableInstance) aCriteria.uniqueResult();
//	}
//	
//	public static List<LogJournal> getProcessInstanceStepVariableList(Session aSession, long idJournal) {
//		Criteria aCriteria = aSession.createCriteria(TransitionInstance.class);
//		aCriteria.add(Expression.eq(TRANSITION_INSTANCE_ID, idJournal));
//		TransitionInstance ti = (TransitionInstance)aCriteria.uniqueResult();
//		List<LogJournal> variables = new ArrayList<LogJournal>();
//		for (Iterator iterator = ti.getLogJournals().iterator(); iterator.hasNext();) {
//			LogJournal lj = (LogJournal) iterator.next();
//			if(lj.getIdLogJournalType() == LogJournalTypeConstants.VARIABLE){
//				variables.add(lj);
//			}
//		}
//		return variables;
//	}
//	
//	public static SchemaMetadata getSchemaDefinition(Session aSession, String idSchema) {
//		Criteria aCriteria = aSession.createCriteria(SchemaMetadata.class);
//		aCriteria.add(Expression.eq("idMetadata", idSchema));
//		return (SchemaMetadata) aCriteria.uniqueResult();
//	}

}
