/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.security;

import java.util.HashMap;
import java.util.Map;

public class SecurityToken {
	
	private String commonName;
	private String organizationalUnit;
	private String organization;
	private String locality;
	private String state;
	private String country;
	private Map<String, String> properties;
	
	public SecurityToken() {
		super();
		this.properties = new HashMap<String, String>();
	}
	
	public SecurityToken(String commonName) {
		this();
		this.commonName = commonName;
	}
	public String getCommonName() {
		return commonName;
	}
	public void setCommonName(String commonName) {
		this.commonName = commonName;
	}
	public String getOrganizationalUnit() {
		return organizationalUnit;
	}
	public void setOrganizationalUnit(String organizationalUnit) {
		this.organizationalUnit = organizationalUnit;
	}
	public String getOrganization() {
		return organization;
	}
	public void setOrganization(String organization) {
		this.organization = organization;
	}
	public String getLocality() {
		return locality;
	}
	public void setLocality(String locality) {
		this.locality = locality;
	}
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}
	public String getCountry() {
		return country;
	}
	public void setCountry(String country) {
		this.country = country;
	}
	
	public void addProperty(String name, String value) {
		properties.put(name, value);		
	}
	public String getProperty(String name) {
		return properties.get(name);		
	}
	public Map<String, String> getProperties() {
		return properties;
	}

}
