/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
/* This file contains code modified from Apache code */
package org.eclipse.ebpm.soap.bindings.soap.impl;

import java.util.List;

import org.eclipse.ebpm.soap.bindings.http.model.Wsdl2HttpHeader;
import org.eclipse.ebpm.soap.bindings.soap.model.wsdl2.Wsdl2SoapHeader;
import org.eclipse.ebpm.soap.bindings.soap.model.wsdl2.Wsdl2SoapMessage;
import org.eclipse.ebpm.soap.bindings.soap.model.wsdl2.Wsdl2SoapModule;
import org.eclipse.ebpm.soap.core.model.AbstractWsdl2Message;

public class Wsdl2SoapMessageImpl extends AbstractWsdl2Message implements Wsdl2SoapMessage {

    private List<Wsdl2SoapModule> soapModules;
    private List<Wsdl2SoapHeader> soapHeaders;
    private List<Wsdl2HttpHeader> httpHeaders;

    /**
     * @return the soapModules
     */
    public List<Wsdl2SoapModule> getSoapModules() {
        return soapModules;
    }

    /**
     * @param soapModules the soapModules to set
     */
    public void setSoapModules(List<Wsdl2SoapModule> soapModules) {
        this.soapModules = soapModules;
    }

    /**
     * @return the soapHeaders
     */
    public List<Wsdl2SoapHeader> getSoapHeaders() {
        return soapHeaders;
    }

    /**
     * @param soapHeaders the soapHeaders to set
     */
    public void setSoapHeaders(List<Wsdl2SoapHeader> soapHeaders) {
        this.soapHeaders = soapHeaders;
    }

    /**
     * @return the httpHeaders
     */
    public List<Wsdl2HttpHeader> getHttpHeaders() {
        return httpHeaders;
    }

    /**
     * @param httpHeaders the httpHeaders to set
     */
    public void setHttpHeaders(List<Wsdl2HttpHeader> httpHeaders) {
        this.httpHeaders = httpHeaders;
    }
    
}
