/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
/* This file contains code modified from Apache code */
package org.eclipse.ebpm.soap.core.model;

import java.util.ArrayList;
import java.util.Collection;

import javax.xml.namespace.QName;

import org.eclipse.ebpm.soap.api.model.wsdl1.Wsdl1Message;
import org.eclipse.ebpm.soap.api.model.wsdl1.Wsdl1Part;

/**

 */
public class AbstractWsdl1Message<T extends Wsdl1Part> extends AbstractMessage implements Wsdl1Message<T> {

    private QName name;
    private String messageName;
    private final Collection<T> parts;
    
    public AbstractWsdl1Message() {
        parts = new ArrayList<T>();
    }
    
    /**
     * @return the messageName
     */
    public String getMessageName() {
        return messageName;
    }
    /**
     * @param messageName the messageName to set
     */
    public void setMessageName(String messageName) {
        this.messageName = messageName;
    }
    /**
     * @return the name
     */
    public QName getName() {
        return name;
    }
    /**
     * @param name the name to set
     */
    public void setName(QName name) {
        this.name = name;
    }
    /**
     * @return the parts
     */
    public Collection<T> getParts() {
        return parts;
    }
    /**
     * @param part the part to add
     */
    public void addPart(T part) {
        parts.add(part);
    }
    
}
