/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
/* This file contains code modified from Apache code */
package org.eclipse.ebpm.soap.interceptors.nmr;

import java.net.URI;

import javax.xml.namespace.QName;
import javax.xml.transform.Source;

import org.eclipse.ebpm.constants.SpagicConstants;
import org.eclipse.ebpm.soap.api.Message;
import org.eclipse.ebpm.soap.bindings.soap.SoapFault;
import org.eclipse.ebpm.soap.core.AbstractInterceptor;

/**

 */
public class NmrFaultOutInterceptor extends AbstractInterceptor {

    public void handleMessage(Message message) {
       
    }

    private SoapFault createFault(org.eclipse.ebpm.messaging.api.Message nm) throws Exception {
    	Source src = nm.getBody();
        
        QName code = (QName) nm.getHeader(SpagicConstants.SOAP_FAULT_CODE);
        QName subcode = (QName) nm.getHeader(SpagicConstants.SOAP_FAULT_SUBCODE);
        String reason = (String) nm.getHeader(SpagicConstants.SOAP_FAULT_REASON);
        URI node = (URI) nm.getHeader(SpagicConstants.SOAP_FAULT_NODE);
        URI role = (URI) nm.getHeader(SpagicConstants.SOAP_FAULT_ROLE);
        SoapFault fault = new SoapFault(code, subcode, reason, node, role, src);
        return fault;
    }

}
