/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
/* This file contains code modified from Apache code */
package org.eclipse.ebpm.soap.interceptors.xml;

import javax.xml.stream.XMLStreamReader;
import javax.xml.stream.XMLStreamWriter;
import javax.xml.transform.dom.DOMSource;

import org.dom4j.Document;
import org.dom4j.io.DOMWriter;
import org.eclipse.ebpm.soap.api.Fault;
import org.eclipse.ebpm.soap.api.Message;
import org.eclipse.ebpm.soap.core.AbstractInterceptor;
import org.eclipse.ebpm.soap.util.stax.StaxUtil;

/**

 */
public class BodyOutInterceptor extends AbstractInterceptor {

    public void handleMessage(Message message) {
    	Document nmDoc = message.getContent(Document.class);
    	try{
    		DOMWriter domWriter = new DOMWriter();
    		org.w3c.dom.Document domDoc = domWriter.write(nmDoc);
    		
    		XMLStreamWriter writer = message.getContent(XMLStreamWriter.class);
    		XMLStreamReader reader = StaxUtil.createReader(new DOMSource(domDoc));
        
            StaxUtil.copy(reader, writer);
        } catch (Exception e) {
        	e.printStackTrace();
            throw new Fault(e);
        }
    }

}
