/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
/* This file contains code modified from Apache code */
package org.eclipse.ebpm.soap.util;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.activation.DataSource;

public class StreamDataSource implements DataSource {

	private InputStream in;
	private String contentType;
	private String name;
	
	public StreamDataSource(InputStream in) {
		this(in, null, null);
	}

	public StreamDataSource(InputStream in, String contentType) {
		this(in, contentType, null);
	}

	public StreamDataSource(InputStream in, String contentType, String name) {
		this.in = in;
		this.contentType = contentType;
		this.name = name;
	}

	public InputStream getInputStream() throws IOException {
		if (in == null) throw new IOException("no data");
		return in;
	}

	public OutputStream getOutputStream() throws IOException {
    	throw new IOException("getOutputStream() not supported");
	}

	public String getContentType() {
		return contentType;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setContentType(String contentType) {
		this.contentType = contentType;
	}

}
