/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
/* This file contains code modified from Apache code */
package org.eclipse.ebpm.soap.ws.security;

import java.net.URI;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;

import javax.xml.namespace.QName;

import org.eclipse.ebpm.soap.api.Message;
import org.eclipse.ebpm.soap.bindings.soap.SoapInterceptor;
import org.eclipse.ebpm.soap.core.AbstractInterceptor;

public class WsSecurityInInterceptor extends AbstractInterceptor implements SoapInterceptor {

    public static QName[] HEADERS = {
    /*
        new QName(WSConstants.WSSE_NS, WSConstants.WSSE_LN),  
        new QName(WSConstants.WSSE11_NS, WSConstants.WSSE_LN),
    */  
    };
    
    private final WsSecurityPolicy policy;
    
    public WsSecurityInInterceptor(WsSecurityPolicy policy) {
        this.policy = policy;
    }
    
    public void handleMessage(Message message) {
        boolean required = policy.isRequired();
        // TODO
    }

    public Collection<QName> getUnderstoodHeaders() {
        return Arrays.asList(HEADERS);
    }

    public Collection<URI> getRoles() {
        return Collections.emptyList();
    }
    
}
