/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
/* This file contains code modified from Apache code */
package org.eclipse.ebpm.soap.wsdl;

import java.util.Iterator;
import java.util.List;

import javax.wsdl.extensions.ExtensibilityElement;
import javax.wsdl.extensions.soap.SOAPAddress;
import javax.wsdl.extensions.soap12.SOAP12Address;

import org.eclipse.ebpm.soap.api.model.Binding;

public class Wsdl1BindingFactory {

    public static Binding<?> createBinding(javax.wsdl.Port wsdlPort) {
        List elements = wsdlPort.getExtensibilityElements();
        for (Iterator iter = elements.iterator(); iter.hasNext();) {
            ExtensibilityElement element = (ExtensibilityElement) iter.next();
            if (element instanceof SOAPAddress) {
                return Wsdl1Soap11BindingFactory.createWsdl1SoapBinding(wsdlPort);
            } else if (element instanceof SOAP12Address) {
                return Wsdl1Soap12BindingFactory.createWsdl1SoapBinding(wsdlPort);
            }
        }
        return null;
    }

}
