/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.workflow.api;

import java.util.Date;

public class ProcessInstance {

	public static final int INSTANCE_RUNNING = 0;
	public static final int INSTANCE_EXECUTED = 1;
	public static final int INSTANCE_FAULTED = 2; 
	public static final int INSTANCE_KILLED = 3; 
	public static final int INSTANCE_EXPIRED = 4; 
	

	private long processInstanceId;
	private String name;
	private int  state;
	private Date start;
	private Date end;
	private Process process;
	
	public long getProcessInstanceId() {
		return processInstanceId;
	}
	public void setProcessInstanceId(long processInstanceId) {
		this.processInstanceId = processInstanceId;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getState() {
		return state;
	}
	public void setState(int state) {
		this.state = state;
	}
	public Date getStart() {
		return start;
	}
	public void setStart(Date start) {
		this.start = start;
	}
	public Date getEnd() {
		return end;
	}
	public void setEnd(Date end) {
		this.end = end;
	}
	public Process getProcess() {
		return process;
	}
	public void setProcess(Process process) {
		this.process = process;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (obj.getClass() != this.getClass()) {
			return false;
		}

		ProcessInstance p = (ProcessInstance) obj;
		if (this.processInstanceId == p.processInstanceId) {
			return true;
		}
		return false;
	}



	@Override
	public int hashCode() {
		// TODO Auto-generated method stub
		return super.hashCode();
	}
	
}
