/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.workflow.api;

import java.util.Date;

public class TaskInstance {
	
	public static final int NOT_GENERATED = 0;
	public static final int GENERATED = 1;
	public static final int COMPLETED = 2; 
	public static final int CANCELLED = 3;
	public static final int STARTED = 4;
	
	private String taskName;
	private long taskId;
	private long taskInternalId;
	private long taskInstanceId;
	private long processId;
	private long processInstanceId;
	private int status = 0;
	private Date creationDate;
	private Date endDate;
	private Date expirationDate;
	private Date acceptanceDate;
	private int completionPercentage = 0;
	private String processName;
	private String associatedFormName;
	private String assignedTo = null;
	
	public String getAssignedTo() {
		return assignedTo;
	}
	public void setAssignedTo(String assignedTo) {
		this.assignedTo = assignedTo;
	}
	public String getTaskName() {
		return taskName;
	}
	public void setTaskName(String taskName) {
		this.taskName = taskName;
	}
	public long getTaskId() {
		return taskId;
	}
	public void setTaskId(long taskId) {
		this.taskId = taskId;
	}
	public long getTaskInternalId() {
		return taskInternalId;
	}
	public void setTaskInternalId(long taskInternalId) {
		this.taskInternalId = taskInternalId;
	}
	public long getTaskInstanceId() {
		return taskInstanceId;
	}
	public void setTaskInstanceId(long taskInstanceId) {
		this.taskInstanceId = taskInstanceId;
	}
	public long getProcessId() {
		return processId;
	}
	public void setProcessId(long processId) {
		this.processId = processId;
	}
	public long getProcessInstanceId() {
		return processInstanceId;
	}
	public void setProcessInstanceId(long processInstanceId) {
		this.processInstanceId = processInstanceId;
	}
	public int getStatus() {
		return status;
	}
	public void setStatus(int status) {
		this.status = status;
	}
	
	public Date getCreationDate() {
		return creationDate;
	}
	public void setCreationDate(Date creationDate) {
		this.creationDate = creationDate;
	}
	
	public Date getEndDate() {
		return endDate;
	}
	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}
	
	public Date getExpirationDate() {
		return expirationDate;
	}
	public void setExpirationDate(Date expirationDate) {
		this.expirationDate = expirationDate;
	}
	
	public Date getAcceptanceDate() {
		return acceptanceDate;
	}
	public void setAcceptanceDate(Date acceptanceDate) {
		this.acceptanceDate = acceptanceDate;
	}
	
	public int getCompletionPercentage() {
		return completionPercentage;
	}
	public void setCompletionPercentage(int completionPercentage) {
		this.completionPercentage = completionPercentage;
	}
	
	public void setProcessName(String processName) {
		this.processName = processName;
	}
	public String getProcessName() {
		return processName;
	}
	public void setAssociatedFormName(String associatedFormName) {
		this.associatedFormName = associatedFormName;
	}
	public String getAssociatedFormName() {
		return associatedFormName;
	}
	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (obj.getClass() != this.getClass()) {
			return false;
		}

		TaskInstance p = (TaskInstance) obj;
		if (this.taskInstanceId == p.taskInstanceId) {
			return true;
		}
		return false;
	}
	
	
}
