package org.spagic3.components.drools.helper;

import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;

import org.eclipse.ebpm.messaging.api.Exchange;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;

public class MessageHelper {

	private DocumentBuilderFactory dbf;
	private Exchange exchange;
	private Document inDoc;
//	private Document outDoc;

	public MessageHelper(Exchange exchange) throws Exception {
		this.exchange = exchange;
		dbf = DocumentBuilderFactory.newInstance();
		dbf.setNamespaceAware(false);
		inDoc = buildDocument((String) this.exchange.getIn().getBodyText());
//		outDoc = buildDocument((String) this.exchange.getOut().getBody());
	}
	
	private Document buildDocument(String xml) throws Exception {
		final DocumentBuilder builder = dbf.newDocumentBuilder();
		final InputSource source = new InputSource(new StringReader(xml));
		final Document document = builder.parse(source);
		return document;
	}

	public boolean xpath(String xpath) throws Exception {
		final XPathFactory factory = XPathFactory.newInstance();
		final XPath xPath = factory.newXPath();
//		xPath.setNamespaceContext(ServiceModelHelper.nsContext);
		Boolean value = (Boolean) xPath.evaluate(xpath, inDoc,
				XPathConstants.BOOLEAN);
		return value;
	}

	public String valueOf(String xpath) throws Exception {
		final XPathFactory factory = XPathFactory.newInstance();
		final XPath xPath = factory.newXPath();
//		xPath.setNamespaceContext(ServiceModelHelper.nsContext);
		String value = (String) xPath.evaluate(xpath, inDoc,
				XPathConstants.STRING);
		return value;
	}

}
