/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.exchanges;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import org.eclipse.ebpm.messaging.api.Exchange;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ExchangeSerializer {
	
	private static final Logger logger = LoggerFactory.getLogger(ExchangeSerializer.class); 
		
	public byte[] toByteArray(Exchange exchange){
		try{
			// Serialize to a byte array 
			ByteArrayOutputStream bos = new ByteArrayOutputStream(); 
			ObjectOutputStream out = new ObjectOutputStream(bos) ; 
			out.writeObject(exchange); 
			out.close(); 
		
			// Get the bytes of the serialized object 
			byte[] buf = bos.toByteArray();
			return buf;
		}catch (IOException e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
	
	public Exchange fromByteArray(byte[] bytes){
		try{
			
			ObjectInputStream in = new ObjectInputStream(new ByteArrayInputStream(bytes)); 
			Exchange e = (Exchange)in.readObject(); 
			in.close(); 
			return e;
		}catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
}
