/*******************************************************************************
 * Copyright (c) 2010 Engineering Group.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.ebpm.service.model;

public interface IServiceModelHelper {
	
	/**
	 * Retrieves the component name starting from the factory name.
	 * @param factoryName
	 * @return Component name or null if no match
	 */
	public String getComponentName(String factoryName);

	/**
	 * Retrieves the component type starting from the factory name.
	 * @param factoryName
	 * @return SERVICE_TYPE_CONNECTOR, SERVICE_TYPE_SERVICE or SERVICE_TYPE_UNDEFINED
	 */
	public String getComponentType(String factoryName);

}
